<?php

namespace App\Models\Scopes;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Scope;

class ImportationGlobalScope implements Scope{

    /**
     * Apply the scope to a given Eloquent query builder.
     *
     * @param Builder $builder
     * @param Model $model
     * @return void
     */
    public function apply(Builder $builder, Model $model){
        $builder->when(request()->filled('warehouse_id'),function ($query){
                    return $query->where('warehouse_id',request()->get("warehouse_id"));
                })
                ->when(request()->filled('categories'),function ($query){
                    return $query->whereHas('product',function ($query){
                        return $query->whereIn('category_id', (array) request()->get('categories'));
                    });
                })
               ;
    }
}
